import * as React from 'react';
import MuiThemeProvider from 'material-ui/styles/MuiThemeProvider';

import { List, ListItem, makeSelectable } from 'material-ui/List';
import Subheader from 'material-ui/Subheader';
import Checkbox from 'material-ui/Checkbox';


let SelectableList = makeSelectable(List);

function wrapState(ComposedComponent: any, par : any) {
    return class SelectableList extends React.Component<any, any> {
        
        constructor(props: any) {
            super(props);
        }

        componentWillMount() {
            this.setState({
                selectedIndex: this.props.defaultValue,
            });
        }

        handleRequestChange = (event: any, index: any) => {
            par.handleSelect(index);
        };

        render() {
            return (
                <ComposedComponent
                    value={this.state.selectedIndex}
                    onChange={this.handleRequestChange}
                >
                    {this.props.children}
                </ComposedComponent>
            );
        }
    };
}



export class TargetSelector extends React.Component<any, any> {
    constructor(props: any, context: any) {
        super(props, context)
        this.state = {
        };
        SelectableList = wrapState(SelectableList, this);
    }

    handleSelect(idx : any) {
        this.props.onChange(idx);
    }

    render() {
        return (
            <MuiThemeProvider >
                <div>
                    <SelectableList ref={'list'} >
                        <Subheader>Select a target to monitor</Subheader>
                        <ListItem
                            value={1}
                            primaryText="192.168.1.0"
                            initiallyOpen={true}
                            nestedItems={[
                                <ListItem
                                    value={2}
                                    primaryText="192.168.1.11"
                                    initiallyOpen={true}
                                    nestedItems={[
                                        <ListItem value={3} primaryText="Redis" secondaryText="5432" />,
                                        <ListItem value={4} primaryText="FTP" secondaryText="5432" />,
                                    ]}
                                />,
                                <ListItem
                                    value={5}
                                    primaryText="192.168.1.12"
                                    initiallyOpen={true}
                                    nestedItems={[
                                        <ListItem value={6} primaryText="MySQL" secondaryText="5432" />,
                                        <ListItem value={7} primaryText="SSH" secondaryText="5432" />,
                                    ]}
                                />,
                                <ListItem
                                    value={8}
                                    primaryText="192.168.1.13"
                                    initiallyOpen={true}
                                    nestedItems={[
                                        <ListItem value={9} primaryText="Tomcat" secondaryText="8080" />,
                                    ]}
                                />,
                            ]}
                        />
                    </SelectableList>
                </div>
            </MuiThemeProvider>
        );
    }
}
