/**
 * In this file, we create a React component
 * which incorporates components provided by Material-UI.
 */
import * as React from 'react';
import RaisedButton from 'material-ui/RaisedButton';
import Dialog from 'material-ui/Dialog';
import { deepOrange500 } from 'material-ui/styles/colors';
import FlatButton from 'material-ui/FlatButton';
import getMuiTheme from 'material-ui/styles/getMuiTheme';
import MuiThemeProvider from 'material-ui/styles/MuiThemeProvider';

import * as ReactDOM from 'react-dom';

import Divider from 'material-ui/Divider';
import Paper from 'material-ui/Paper';
import TextField from 'material-ui/TextField';

import SelectField from 'material-ui/SelectField';
import MenuItem from 'material-ui/MenuItem';

import Slider from 'material-ui/Slider';

import * as http from "http"

import { MemberRegistResult } from './registResult';

import { OFRest } from '../../components/rest';


const styles = {
  body: {
    textAlign: 'center',
  },
  container: {
    textAlign: 'center',

  },

  textfield: {
    width: 300,
    marginLeft: 3
  },

  customWidth: {
    width: 150,
  },
  button: {
    margin: 12,
  }
};

const muiTheme = getMuiTheme({
  palette: {
    accent1Color: deepOrange500,
  },
});

var EMailRegex = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

export class MemberRegist extends React.Component<any, any> {
  constructor(props: any, context: any) {
    super(props, context);

    this.handleSignUp = this.handleSignUp.bind(this);



    this.state = {
      open: false,
      value: 1,

      id: 0,
      email: "",
      name: "",
      company: "",
      phone: "",
      pw: "",

      isEmail: true
    };
  }

  handleChange = () => this.setState({});

  private emailInput: any;



  handleSignUp = () => {

    let output: string;
    let obj: any; //new object declaration
    obj = {
      "email": this.state.email,
      "pwSalt": this.state.pw,
      "name": this.state.name,
      "company": this.state.company,
      "phone": this.state.phone
    };

    

         let os: OFRest = new OFRest("Member", "Regist", obj);

         os.Call().then(function (res) {
            return res.json();
         }).then(function(json) {
     console.log(json);
     ReactDOM.render(<MemberRegistResult />, document.getElementById('example'));
         }).catch(function(err) {
    console.log(err);
         });

  }

  public validateEmail(email: any) {
    return EMailRegex.test(email);
  }

  handleTestRead = () => {
    let output: string;
    let obj: any; //new object declaration
    obj = {
      "id": this.state.id,
      "email": this.state.email,
      "pwSalt": this.state.pw,
      "name": this.state.name,
      "company": this.state.company,
      "phone": this.state.phone
    };

    let exeObj: any;
    exeObj = {
      "serviceName": "Member",
      "methodName": "Read",
      "param": obj
    };


    output = JSON.stringify(exeObj);


    fetch('http://192.168.1.203:8080/v1/overflow/services', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        // mode: 'no-cors'
      },
      body: output
    }).then(function (response) {
      return response.json();
    }).then(function (json) {
      console.log(json);
    }).catch((err) => {
      console.log(err);
    });
  }

  handleTestUpdate = () => {
    let output: string;
    let obj: any; //new object declaration
    obj = {
      "id": this.state.id,
      "email": this.state.email,
      "pwSalt": this.state.pw,
      "name": this.state.name,
      "company": this.state.company,
      "phone": this.state.phone
    };

    let exeObj: any;
    exeObj = {
      "serviceName": "Member",
      "methodName": "Modify",
      "param": obj
    };


    output = JSON.stringify(exeObj);


    fetch('http://192.168.1.203:8080/v1/overflow/services', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        // mode: 'no-cors'
      },
      body: output
    }).then(function (response) {
      return response.json();
    }).then(function (json) {
      console.log(json);
    }).catch((err) => {
      console.log(err);
    });
  }

  handleTestDelete = () => {
    let output: string;
    let obj: any; //new object declaration
    obj = {
      "id": this.state.id,
      "email": this.state.email,
      "pwSalt": this.state.pw,
      "name": this.state.name,
      "company": this.state.company,
      "phone": this.state.phone
    };

    let exeObj: any;
    exeObj = {
      "serviceName": "Member",
      "methodName": "Remove",
      "param": obj
    };


    output = JSON.stringify(exeObj);


    fetch('http://192.168.1.203:8080/v1/overflow/services', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        // mode: 'no-cors'
      },
      body: output
    }).then(function (response) {
      return response.json();
    }).then(function (json) {
      console.log(json);
    }).catch((err) => {
      console.log(err);
    });
  }


  handleResultContainer = () => {
    ReactDOM.render(
      <MemberRegistResult />,
      document.getElementById('example')
    );
  }


  btnTouchTap = () => {
    alert(event)
  };

  render() {

    return (
      <MuiThemeProvider muiTheme={muiTheme}>

        <div style={styles.container}>
          Get started with Overflow
              <br />
          <TextField
            ref="email"
            hintText="smith@gmail.com"
            floatingLabelText="Email address*"
            errorText={this.state.isEmail ? "":"Please Email Format"}
            style={styles.textfield}
            underlineShow={true}
            value={this.state.email}
            onChange={(e, newValue) => {
              this.setState({ email: newValue });

              this.state.isEmail = this.validateEmail(this.state.email);
            }
            }
          />
          <br />
          <TextField
            ref="name"
            hintText="Snoop"
            floatingLabelText="Full Name*"
            style={styles.textfield}
            underlineShow={true}
            value={this.state.name}
            onChange={(e, newValue) => this.setState({ name: newValue })}

          />
          <br />

          <TextField
            ref="company"
            hintText="Loafle"
            floatingLabelText="Company*"
            style={styles.textfield}
            underlineShow={true}
            value={this.state.company}
            onChange={(e, newValue) => this.setState({ company: newValue })}
          />
          <br />

          <TextField
            ref="phone"
            hintText="Loafle"
            floatingLabelText="Phone*"
            style={styles.textfield}
            underlineShow={true}
            value={this.state.phone}
            onChange={(e, newValue) => this.setState({ phone: newValue })}
          />
          <br />

          <TextField
            hintText="Password"
            floatingLabelText="Password"
            type="password"
            style={styles.textfield}
            value={this.state.pw}
            onChange={(e, newValue) => this.setState({ pw: newValue })}
          />
          <br />


          <RaisedButton label="Sign Up" primary={true} style={styles.button} onClick={this.handleSignUp.bind(this)} />
          <RaisedButton label="Read" primary={true} style={styles.button} onClick={this.handleTestRead.bind(this)} />
          <RaisedButton label="Update" primary={true} style={styles.button} onClick={this.handleTestUpdate.bind(this)} />
          <RaisedButton label="Delete" primary={true} style={styles.button} onClick={this.handleTestDelete.bind(this)} />
          <br />
          <TextField
            hintText="id"
            floatingLabelText="id"

            style={styles.textfield}
            value={this.state.id}
            onChange={(e, newValue) => this.setState({ id: newValue })}
          />
        </div>

      </MuiThemeProvider>
    );
  }
}

